%>  *********************************************************************** 
%>   Copyright © 2017-2021 ETH Zurich, Andreas P. Cuny, Tomas Kuendig, 
%>   Aaron Ponti, Joerg Stelling; D-BSSE; CSB Group 
%>   All rights reserved. This program and the accompanying materials 
%>   are made available under the terms of the BSD-3 Clause License 
%>   which accompanies this distribution, and is available at 
%>   https://gitlab.com/csb.ethz/tracx/-/blob/master/LICENSE.rst 
%>    
%>  ***********************************************************************
function insertNewData(this, absentFrameArray, trackArray, ...
    fingerprintHalfWindowSideLength, ...
    fingerprintMaxConsideredFrequencies, ...
    imageDir, imageFingerprintFileArray, imageCropCoordinateArray, ...
    neighbourhoodSearchRadius)
% INSERTNEWDATA Inserts a virtual object into
% :class:`~+TracX.@SegmentationData.SegmentationData` for a certain track in 
% a certain image frame. Due to miss- or missing segmentation on some frames 
% the existing data is wrong or missing and should not be used for tracking. 
% But that a cell trace continues to exist on all image frames a
% virtual 'cell' with properties from the last existing valid
% occurance wil be added.
%
% Args:
%    this (:obj:`object`):                             :class:`TrackerData` instance.       
%    absentFrameArray (:obj:`array`, 1xN):             Array with frame
%                                                      numbers where a
%                                                      selected track is
%                                                      not present.
%    trackArray (:obj:`array`, 1xN):                   Array with track indicies.
%    fingerprintHalfWindowSideLength (:obj:`int`):     :class:`~+TracX.@ParameterConfiguration.ParameterConfiguration.fingerprintHalfWindowSideLength`
%    fingerprintMaxConsideredFrequencies (:obj:`int`): :class:`~+TracX.@ParameterConfiguration.ParameterConfiguration.fingerprintMaxConsideredFrequencies` 
%    imageDir (:obj:`array`):                          :class:`~+TracX.@ProjectConfiguration.ProjectConfiguration.imageDir` 
%    imageFingerprintFileArray (:obj:`array`):         :class:`~+TracX.@ProjectConfiguration.ProjectConfiguration.imageFingerprintFileArray`
%    imageCropCoordinateArray (:obj:`array`, 1x4):     :class:`~+TracX.@ProjectConfiguration.ProjectConfiguration.imageCropCoordinateArray` 
%    neighbourhoodSearchRadius (:obj:`int`):           :class:`~+TracX.@ParameterConfiguration.ParameterConfiguration.neighbourhoodSearchRadius` 
%
% Returns
% -------
%    void :obj:`-` 
%
% :Authors:
%    Andreas P. Cuny - initial implementation

fieldNames = fieldnames(this.SegmentationData);
NfieldNames = numel(fieldNames);
for iTrack = 1:numel(trackArray)
    for k = 1:numel(absentFrameArray)
        % Create new instance of SegmentationDataObj
        NewCell = TracX.SegmentationData();
        % Prepare arguments for new instance
        uuid = max(this.SegmentationData.uuid) + 1;
        cell_frame = absentFrameArray(k);
        cell_index = nan;
        cell_center_x = this.getFieldArrayForTrackIndexForFrame(...
            'cell_center_x', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_center_y = this.getFieldArrayForTrackIndexForFrame(...
            'cell_center_y', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_majoraxis = this.getFieldArrayForTrackIndexForFrame(...
            'cell_majoraxis', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_minoraxis = this.getFieldArrayForTrackIndexForFrame(...
            'cell_minoraxis', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_orientation = this.getFieldArrayForTrackIndexForFrame(...
            'cell_orientation', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_area = this.getFieldArrayForTrackIndexForFrame('cell_area', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_volume = nan;
        cell_perimeter = nan;
        cell_eccentricity = this.getFieldArrayForTrackIndexForFrame(...
            'cell_eccentricity', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_fractionOfGoodMembranePixels = nan;
        cell_mem_area = nan;
        cell_mem_volume = nan;
        cell_nuc_radius = nan;
        cell_nuc_area = nan;
        x = [this.getFieldArrayForFrame('cell_center_x', ...
            absentFrameArray(k)); cell_center_x];
        y = [this.getFieldArrayForFrame('cell_center_y', ...
            absentFrameArray(k)); cell_center_y];
        cell_close_neighbour = TracX.Functions.getCloseCellNeighbourIdx(...
            x, y, neighbourhoodSearchRadius);
        cell_dif_x = nan;
        cell_dif_y = nan;
        cell_filtered_dif_x = this.getFieldArrayForTrackIndexForFrame(...
            'cell_filtered_dif_x', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_filtered_dif_y = this.getFieldArrayForTrackIndexForFrame(...
            'cell_filtered_dif_y', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        cell_pole1_x = nan;
        cell_pole1_y = nan;
        cell_pole2_x = nan;
        cell_pole2_y = nan;
        cell_pole1_age = nan;
        cell_pole2_age = nan;
        % Tracking Data
        track_index = this.getFieldArrayForTrackIndexForFrame('track_index', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        track_index_qc = nan;
        [ret_fq] = TracX.Functions.computeFingerprint(...
            absentFrameArray(k), absentFrameArray(k),  ...
            fingerprintHalfWindowSideLength, ...
            fingerprintMaxConsideredFrequencies, ...
            imageDir, imageFingerprintFileArray, imageCropCoordinateArray, ...
            cell_frame, cell_center_x, cell_center_y);
        track_fingerprint_real = ret_fq; % [ret_fq{1}];
        track_fingerprint_real_distance = nan;
        track_age = this.getFieldArrayForTrackIndexForFrame(...
            'track_age', absentFrameArray(k)-1, trackArray(iTrack));
        track_parent = this.getFieldArrayForTrackIndexForFrame( ...
            'track_parent', absentFrameArray(k)-1, trackArray(iTrack));
        track_parent_frame = this.getFieldArrayForTrackIndexForFrame(...
            'track_parent_frame', absentFrameArray(k)-1, trackArray(iTrack));
        track_generation = this.getFieldArrayForTrackIndexForFrame(...
            'track_generation', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        track_lineage = this.getFieldArrayForTrackIndexForFrame(...
            'track_lineage', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        track_assignment_faction = nan;
        track_total_assignment_cost = nan;
        track_position_assignment_cost = nan;
        track_area_assignment_cost = nan;
        track_rotation_assignment_cost = nan;
        track_frame_skipping_cost = nan;
        track_start_frame = this.getFieldArrayForTrackIndexForFrame(...
            'track_start_frame', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        track_end_frame = this.getFieldArrayForTrackIndexForFrame(...
            'track_end_frame', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        track_index_corrected = nan;
        track_contained_in_track = this.getFieldArrayForTrackIndexForFrame(...
            'track_contained_in_track', ...
            absentFrameArray(k)-1, trackArray(iTrack));
        track_has_bud = 0;
        
        % Init new instance
        NewCell.initNewEntry(uuid, cell_frame, ...
            cell_index, cell_center_x,...
            cell_center_y, cell_majoraxis, cell_minoraxis, ...
            cell_orientation, cell_area, cell_volume, ...
            cell_perimeter, cell_eccentricity, ...
            cell_fractionOfGoodMembranePixels, cell_mem_area, ...
            cell_mem_volume, cell_nuc_radius, cell_nuc_area,...
            cell_close_neighbour, cell_dif_x, cell_dif_y, ...
            cell_filtered_dif_x, cell_filtered_dif_y, ...
            cell_pole1_x, cell_pole1_y, cell_pole2_x, ...
            cell_pole2_y, cell_pole1_age, cell_pole2_age, ...
            track_index, track_index_qc, ...
            track_fingerprint_real, ...
            track_fingerprint_real_distance,...
            track_age, track_parent, track_parent_frame, ...
            track_generation, track_lineage, ...
            track_assignment_faction, ...
            track_total_assignment_cost, ...
            track_position_assignment_cost, ...
            track_area_assignment_cost, ...
            track_rotation_assignment_cost, ...
            track_frame_skipping_cost, track_start_frame, ...
            track_end_frame, track_index_corrected, ...
            track_contained_in_track, track_has_bud);
        
        % Insert new virtual cell into SegmentationData for each
        % absent frame.
        insertIdx = find(this.SegmentationData.cell_frame == ...
            absentFrameArray(k), 1, 'last') + 1;
        for n = 1:NfieldNames
            if ~strcmp(fieldNames(n), 'cell_close_neighbour')
                % insert
                if ~isempty(this.SegmentationData.(fieldNames{n}))
                    if ~strcmp(fieldNames(n), 'uuid')
                        this.SegmentationData.(fieldNames{n}) = ...
                            this.insertValAtIdx(...
                            this.SegmentationData.(fieldNames{n}), ...
                            NewCell.(fieldNames{n}), insertIdx)';
                    else
                        this.SegmentationData.setUUID(this.insertValAtIdx(...
                            this.SegmentationData.(fieldNames{n}), ...
                            NewCell.(fieldNames{n}), insertIdx)');
                    end
                end
            else
                this.SegmentationData.cell_close_neighbour(...
                    absentFrameArray(k)).Indicies = ...
                    NewCell.(fieldNames{n}).Indicies;
            end
        end
    end
    % Calculate fingerprint distance for all tracks
    % and frames that have been updated
    % TrackerFunctions.get_fingerprintDist(...
    % fingerprintsOldFrame, fingerprintsNewFrame);
    
end

end